// FormF.cpp : implementation file
//

#include "stdafx.h"
#include "SurfX3D.h"
#include "FormF.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormF

IMPLEMENT_DYNCREATE(CFormF, CFormView)

CFormF::CFormF()
	: CFormView(CFormF::IDD)
{
	//{{AFX_DATA_INIT(CFormF)
	m_sFuncEquation = _T("");
	m_sBEquation = _T("");
	m_sGEquation = _T("");
	m_sREquation = _T("");
	m_sC1 = _T("");
	m_sC2 = _T("");
	m_sC3 = _T("");
	m_sC4 = _T("");
	m_sC5 = _T("");
	m_sC6 = _T("");
	m_sC7 = _T("");
	m_sC8 = _T("");
	m_scale = 100.0;
	m_show_axis = FALSE;
	m_is_color = FALSE;
	m_nzplanes = 0;
	m_xmax = 0.0;
	m_xmin = 0.0;
	m_xytilt = 0.0;
	m_ymax = 0.0;
	m_ymin = 0.0;
	m_zmax = 0.0;
	m_zmin = 0.0;
	m_zrotate = 0.0;
	m_is_transparent = FALSE;
	m_draw_lines = FALSE;
	m_is_clip_inverted = FALSE;
	m_sphere_radius  = 10.0;
	m_sphere_xcenter = 0.0;
	m_sphere_ycenter = 0.0;
	m_sphere_zcenter = 0.0;
	m_sSurfaceName = _T("");
	//}}AFX_DATA_INIT
}

CFormF::~CFormF()
{
}

void CFormF::LoadDlg()
{
	m_sSurfaceName  = theApp.m_plot3DF.m_sSurfaceName;
	m_sC1           = theApp.m_plot3DF.m_sC1;
	m_sC2           = theApp.m_plot3DF.m_sC2;
	m_sC3           = theApp.m_plot3DF.m_sC3;
	m_sC4           = theApp.m_plot3DF.m_sC4;
	m_sC5           = theApp.m_plot3DF.m_sC5;
	m_sC6           = theApp.m_plot3DF.m_sC6;
	m_sC7           = theApp.m_plot3DF.m_sC7;
	m_sC8           = theApp.m_plot3DF.m_sC8;
	m_sFuncEquation = theApp.m_plot3DF.m_sFuncEquation;
	m_sBEquation    = theApp.m_plot3DF.m_sBEquation;
	m_sREquation    = theApp.m_plot3DF.m_sREquation;
	m_sGEquation    = theApp.m_plot3DF.m_sGEquation;

	// common parameters
	m_zrotate       = theApp.m_plot3DF.m_zrotate;      
	m_xytilt        = theApp.m_plot3DF.m_xytilt;       
	m_scale         = theApp.m_plot3DF.m_scale;        
	m_line_color    = theApp.m_plot3DF.m_line_color;   
	m_back_color    = theApp.m_plot3DF.m_back_color;   
	m_is_color      = theApp.m_plot3DF.m_is_color;     
	m_is_transparent= !theApp.m_plot3DF.m_remove_hidden;
	m_show_axis     = theApp.m_plot3DF.m_show_axis;    

	// specific parameters
	m_xmin             = theApp.m_plot3DF.m_xmin;       
	m_xmax             = theApp.m_plot3DF.m_xmax;       
	m_ymin             = theApp.m_plot3DF.m_ymin;       
 	m_ymax             = theApp.m_plot3DF.m_ymax;       
	m_zmin             = theApp.m_plot3DF.m_zmin;       
 	m_zmax             = theApp.m_plot3DF.m_zmax;       
	m_nzplanes         = theApp.m_plot3DF.m_nzplanes;    
	m_draw_lines       = theApp.m_plot3DF.m_draw_lines      ;
	m_clip_mode        = theApp.m_plot3DF.m_clip_mode       ;
	m_is_clip_inverted = theApp.m_plot3DF.m_is_clip_inverted;
	m_use_sphere_range = theApp.m_plot3DF.m_use_sphere_range;
	m_sphere_radius    = theApp.m_plot3DF.m_sphere_radius   ;
	m_sphere_xcenter   = theApp.m_plot3DF.m_sphere_xcenter  ;
	m_sphere_ycenter   = theApp.m_plot3DF.m_sphere_ycenter  ;
	m_sphere_zcenter   = theApp.m_plot3DF.m_sphere_zcenter  ;
	UpdateData(FALSE);	// set values into dialog

	CButton* pBtnCube   = (CButton*)GetDlgItem(IDC_RADIO_RANGE_CUBE);
	CButton* pBtnSphere = (CButton*)GetDlgItem(IDC_RADIO_RANGE_SPHERE);
	if (m_use_sphere_range)
	{
		pBtnCube->SetCheck(0);
		pBtnSphere->SetCheck(1);
	}
	else
	{
		pBtnCube->SetCheck(1);
		pBtnSphere->SetCheck(0);
	}

	CButton* pBtnClipNone   = (CButton*)GetDlgItem(IDC_RADIO_CLIP_NONE);
	CButton* pBtnClipSphere = (CButton*)GetDlgItem(IDC_RADIO_CLIP_SPHERE);
	CButton* pBtnClipCube   = (CButton*)GetDlgItem(IDC_RADIO_CLIP_CUBE);
	if (m_clip_mode==Plot3DF::CLIP_CUBE)
	{
		pBtnClipNone->SetCheck(0);
		pBtnClipCube->SetCheck(1);
		pBtnClipSphere->SetCheck(0);
	}
	else if (m_clip_mode==Plot3DF::CLIP_SPHERE)
	{
		pBtnClipNone->SetCheck(0);
		pBtnClipCube->SetCheck(0);
		pBtnClipSphere->SetCheck(1);
	}
	else
	{
		pBtnClipNone->SetCheck(1);
		pBtnClipCube->SetCheck(0);
		pBtnClipSphere->SetCheck(0);
	}
}

void CFormF::GetDlg()
{
	UpdateData(TRUE);	// get values from dialog
	theApp.m_plot3DF.m_sSurfaceName  = m_sSurfaceName  ;
	theApp.m_plot3DF.m_sC1           = m_sC1           ;
	theApp.m_plot3DF.m_sC2           = m_sC2           ;
	theApp.m_plot3DF.m_sC3           = m_sC3           ;
	theApp.m_plot3DF.m_sC4           = m_sC4           ;
	theApp.m_plot3DF.m_sC5           = m_sC5           ;
	theApp.m_plot3DF.m_sC6           = m_sC6           ;
	theApp.m_plot3DF.m_sC7           = m_sC7           ;
	theApp.m_plot3DF.m_sC8           = m_sC8           ;
	theApp.m_plot3DF.m_sFuncEquation = m_sFuncEquation ;
	theApp.m_plot3DF.m_sBEquation    = m_sBEquation;
	theApp.m_plot3DF.m_sREquation    = m_sREquation;
	theApp.m_plot3DF.m_sGEquation    = m_sGEquation;

	// common parameters
	theApp.m_plot3DF.m_zrotate       = m_zrotate      ;      
	theApp.m_plot3DF.m_xytilt        = m_xytilt       ;       
	theApp.m_plot3DF.m_scale         = m_scale        ;        
	theApp.m_plot3DF.m_line_color    = m_line_color   ;   
	theApp.m_plot3DF.m_back_color    = m_back_color   ;   
	theApp.m_plot3DF.m_is_color      = m_is_color     ;     
	theApp.m_plot3DF.m_remove_hidden = !m_is_transparent;
	theApp.m_plot3DF.m_show_axis     = m_show_axis    ;    

	// specific parameters
	theApp.m_plot3DF.m_xmin             = m_xmin            ;       
	theApp.m_plot3DF.m_xmax             = m_xmax            ;       
	theApp.m_plot3DF.m_ymin             = m_ymin            ;       
 	theApp.m_plot3DF.m_ymax             = m_ymax            ;       
	theApp.m_plot3DF.m_zmin             = m_zmin            ;       
 	theApp.m_plot3DF.m_zmax             = m_zmax            ;       
	theApp.m_plot3DF.m_nzplanes         = m_nzplanes        ;    
	theApp.m_plot3DF.m_draw_lines       = m_draw_lines      ;
	theApp.m_plot3DF.m_is_clip_inverted = m_is_clip_inverted;
	theApp.m_plot3DF.m_use_sphere_range = m_use_sphere_range;
	theApp.m_plot3DF.m_clip_mode        = m_clip_mode       ;
	theApp.m_plot3DF.m_sphere_radius    = m_sphere_radius   ;
	theApp.m_plot3DF.m_sphere_xcenter   = m_sphere_xcenter  ;
	theApp.m_plot3DF.m_sphere_ycenter   = m_sphere_ycenter  ;
	theApp.m_plot3DF.m_sphere_zcenter   = m_sphere_zcenter  ;
}

int CFormF::IsDataChanged()
{
	UpdateData(TRUE);
	if (theApp.m_plot3DF.m_sSurfaceName  != m_sSurfaceName  ) return(1);
	if (theApp.m_plot3DF.m_sC1           != m_sC1           ) return(1);
	if (theApp.m_plot3DF.m_sC2           != m_sC2           ) return(1);
	if (theApp.m_plot3DF.m_sC3           != m_sC3           ) return(1);
	if (theApp.m_plot3DF.m_sC4           != m_sC4           ) return(1);
	if (theApp.m_plot3DF.m_sC5           != m_sC5           ) return(1);
	if (theApp.m_plot3DF.m_sC6           != m_sC6           ) return(1);
	if (theApp.m_plot3DF.m_sC7           != m_sC7           ) return(1);
	if (theApp.m_plot3DF.m_sC8           != m_sC8           ) return(1);
	if (theApp.m_plot3DF.m_sFuncEquation != m_sFuncEquation ) return(1);
	if (theApp.m_plot3DF.m_sBEquation    != m_sBEquation    ) return(1);
	if (theApp.m_plot3DF.m_sREquation    != m_sREquation    ) return(1);
	if (theApp.m_plot3DF.m_sGEquation    != m_sGEquation    ) return(1);

	// common parameters
	if (theApp.m_plot3DF.m_zrotate       != m_zrotate      ) return(1);      
	if (theApp.m_plot3DF.m_xytilt        != m_xytilt       ) return(1);       
	if (theApp.m_plot3DF.m_scale         != m_scale        ) return(1);        
	if (theApp.m_plot3DF.m_line_color    != m_line_color   ) return(1);   
	if (theApp.m_plot3DF.m_back_color    != m_back_color   ) return(1);   
	if (theApp.m_plot3DF.m_is_color      != m_is_color     ) return(1);     
	if (theApp.m_plot3DF.m_remove_hidden != !m_is_transparent) return(1);
	if (theApp.m_plot3DF.m_show_axis     != m_show_axis    ) return(1);    

	// specific parameters
	if (theApp.m_plot3DF.m_xmin             != m_xmin            ) return(1);       
	if (theApp.m_plot3DF.m_xmax             != m_xmax            ) return(1);       
	if (theApp.m_plot3DF.m_ymin             != m_ymin            ) return(1);       
 	if (theApp.m_plot3DF.m_ymax             != m_ymax            ) return(1);       
	if (theApp.m_plot3DF.m_zmin             != m_zmin            ) return(1);       
 	if (theApp.m_plot3DF.m_zmax             != m_zmax            ) return(1);       
	if (theApp.m_plot3DF.m_nzplanes         != m_nzplanes        ) return(1);    
	if (theApp.m_plot3DF.m_draw_lines       != m_draw_lines      ) return(1);
	if (theApp.m_plot3DF.m_is_clip_inverted != m_is_clip_inverted) return(1);
	if (theApp.m_plot3DF.m_use_sphere_range != m_use_sphere_range) return(1);
	if (theApp.m_plot3DF.m_clip_mode        != m_clip_mode       ) return(1);
	if (theApp.m_plot3DF.m_sphere_radius    != m_sphere_radius   ) return(1);
	if (theApp.m_plot3DF.m_sphere_xcenter   != m_sphere_xcenter  ) return(1);
	if (theApp.m_plot3DF.m_sphere_ycenter   != m_sphere_ycenter  ) return(1);
	if (theApp.m_plot3DF.m_sphere_zcenter   != m_sphere_zcenter  ) return(1);
	return(0);
}

void CFormF::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFormF)
	DDX_Text(pDX, IDC_EDIT_C1, m_sC1);
	DDX_Text(pDX, IDC_EDIT_C2, m_sC2);
	DDX_Text(pDX, IDC_EDIT_C3, m_sC3);
	DDX_Text(pDX, IDC_EDIT_C4, m_sC4);
	DDX_Text(pDX, IDC_EDIT_C5, m_sC5);
	DDX_Text(pDX, IDC_EDIT_C6, m_sC6);
	DDX_Text(pDX, IDC_EDIT_C7, m_sC7);
	DDX_Text(pDX, IDC_EDIT_C8, m_sC8);
	DDX_Text(pDX, IDC_EDIT_BLUE_EQUATION, m_sBEquation);
	DDX_Text(pDX, IDC_EDIT_GREEN_EQUATION, m_sGEquation);
	DDX_Text(pDX, IDC_EDIT_RED_EQUATION, m_sREquation);
	DDX_Text(pDX, IDC_EDIT_PLOT_EQUATION, m_sFuncEquation);
	DDX_Text(pDX, IDC_EDIT_SCALE, m_scale);
	DDX_Check(pDX, IDC_CHECK_SHOW_AXIS, m_show_axis);
	DDX_Check(pDX, IDC_CHECK_IS_COLOR, m_is_color);
	DDX_Text(pDX, IDC_EDIT_NZPLANES, m_nzplanes);
	DDX_Text(pDX, IDC_EDIT_XMAX, m_xmax);
	DDX_Text(pDX, IDC_EDIT_XMIN, m_xmin);
	DDX_Text(pDX, IDC_EDIT_XYTILT, m_xytilt);
	DDX_Text(pDX, IDC_EDIT_YMAX, m_ymax);
	DDX_Text(pDX, IDC_EDIT_YMIN, m_ymin);
	DDX_Text(pDX, IDC_EDIT_ZMAX, m_zmax);
	DDX_Text(pDX, IDC_EDIT_ZMIN, m_zmin);
	DDX_Text(pDX, IDC_EDIT_ZROTATE, m_zrotate);
	DDX_Check(pDX, IDC_CHECK_HIDDEN_LINE_REMOVAL, m_is_transparent);
	DDX_Check(pDX, IDC_CHECK_DRAW_LINES, m_draw_lines);
	DDX_Check(pDX, IDC_CHECK_INVERT_CLIPPING, m_is_clip_inverted);
	DDX_Text(pDX, IDC_SPHERE_RADIUS, m_sphere_radius);
	DDX_Text(pDX, IDC_SPHERE_XCENTER, m_sphere_xcenter);
	DDX_Text(pDX, IDC_SPHERE_YCENTER, m_sphere_ycenter);
	DDX_Text(pDX, IDC_SPHERE_ZCENTER, m_sphere_zcenter);
	DDX_Text(pDX, IDC_EDIT_SURFNAME, m_sSurfaceName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFormF, CFormView)
	//{{AFX_MSG_MAP(CFormF)
	ON_BN_CLICKED(IDC_BTN_BACK_COLOR, OnBtnBackColor)
	ON_BN_CLICKED(IDC_BTN_LINE_COLOR, OnBtnLineColor)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_RADIO_CLIP_CUBE, OnRadioClipCube)
	ON_BN_CLICKED(IDC_RADIO_CLIP_NONE, OnRadioClipNone)
	ON_BN_CLICKED(IDC_RADIO_CLIP_SPHERE, OnRadioClipSphere)
	ON_BN_CLICKED(IDC_RADIO_RANGE_CUBE, OnRadioRangeCube)
	ON_BN_CLICKED(IDC_RADIO_RANGE_SPHERE, OnRadioRangeSphere)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormF diagnostics

#ifdef _DEBUG
void CFormF::AssertValid() const
{
	CFormView::AssertValid();
}

void CFormF::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFormF message handlers

void CFormF::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	LoadDlg();
}

// ------------------------------------------------------
void CFormF::UpdateForm()
{
	// set color buttons
	CWnd* pWnd;
	RECT rect;
	pWnd = (CWnd *)GetDlgItem(IDC_STATIC_FG);
	if (pWnd)
	{
		pWnd->GetClientRect(&rect);
		pWnd->GetDC()->FillSolidRect(&rect,m_line_color);
		pWnd->Invalidate();
	}

	pWnd = (CWnd *)GetDlgItem(IDC_STATIC_BG);
	if (pWnd)
	{
		pWnd->GetClientRect(&rect);
		pWnd->GetDC()->FillSolidRect(&rect,m_back_color);
		pWnd->Invalidate();
	}
}

// ------------------------------------------------------
void CFormF::OnBtnBackColor() 
{
	CColorDialog dlg(m_back_color,CC_ANYCOLOR,this);
	if (dlg.DoModal() != IDOK) return;
	m_back_color = dlg.GetColor();
	UpdateForm();
}

// ------------------------------------------------------
void CFormF::OnBtnLineColor() 
{
	CColorDialog dlg(m_line_color,CC_ANYCOLOR,this);
	if (dlg.DoModal() != IDOK) return;
	m_line_color = dlg.GetColor();
	UpdateForm();
}

// ------------------------------------------------------
void CFormF::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	UpdateForm();
	// Do not call CFormView::OnPaint() for painting messages
}

// ------------------------------------------------------
void CFormF::OnRadioClipCube() 
{
	m_clip_mode = Plot3DF::CLIP_CUBE;
}

// ------------------------------------------------------
void CFormF::OnRadioClipNone() 
{
	m_clip_mode = Plot3DF::CLIP_NONE;
}

// ------------------------------------------------------
void CFormF::OnRadioClipSphere() 
{
	m_clip_mode = Plot3DF::CLIP_SPHERE;
}

// ------------------------------------------------------
void CFormF::OnRadioRangeCube() 
{
	m_use_sphere_range = 0;
}

// ------------------------------------------------------
void CFormF::OnRadioRangeSphere() 
{
	m_use_sphere_range = 1;
}

// ------------------------------------------------------
